
library(rJava)


.onAttach <- function(libname, pkgname) {
  .jpackage(pkgname,lib.loc=libname)

  .loadJars()
}


.onDetach <- function(libpath) {

}

.loadJars <- function() {

  pwd = getwd()

  if(grepl("RStats",pwd)) {
    path = substr(pwd, 1, nchar(pwd)-7)
  }
  else {
    path = pwd
  }

  .jcall("java/lang/System","S","setProperty","config.file","/root/application.conf")
  .jaddClassPath(paste(path, '/stats/target/rassp-stats-0.0.1-SNAPSHOT.jar', sep=""))
  .jaddClassPath(paste(path, '/stats/target/commons-math3-3.0.jar', sep=""))
  .jaddClassPath(paste(path, '/stats/target/jama-1.0.3.jar', sep=""))
  .jaddClassPath(paste(path, '/stats/target/log4j-1.2.17.jar', sep=""))
  .jaddClassPath(paste(path, '/proto/target/rassp-proto-0.0.1-SNAPSHOT.jar', sep=""))
  .jaddClassPath(paste(path, '/proto/target/dependency/aeron-client-1.0.4.jar', sep=""))
  .jaddClassPath(paste(path, '/proto/target/dependency/akka-cluster_2.11-2.4.16.jar', sep=""))
  .jaddClassPath(paste(path, '/proto/target/dependency/akka-cluster-tools_2.11-2.4.16.jar', sep=""))
  .jaddClassPath(paste(path, '/proto/target/dependency/config-1.3.0.jar', sep=""))
  .jaddClassPath(paste(path, '/proto/target/dependency/json4s-ast_2.11-3.4.0.jar', sep=""))
  .jaddClassPath(paste(path, '/proto/target/dependency/junit-3.8.1.jar', sep=""))
  .jaddClassPath(paste(path, '/proto/target/dependency/scala-java8-compat_2.11-0.7.0.jar', sep=""))
  .jaddClassPath(paste(path, '/proto/target/dependency/scala-xml_2.11-1.0.5.jar', sep=""))
  .jaddClassPath(paste(path, '/proto/target/dependency/aeron-driver-1.0.4.jar', sep=""))
  .jaddClassPath(paste(path, '/proto/target/dependency/akka-protobuf_2.11-2.4.16.jar', sep=""))
  .jaddClassPath(paste(path, '/proto/target/dependency/jackson-annotations-2.6.0.jar', sep=""))
  .jaddClassPath(paste(path, '/proto/target/dependency/json4s-core_2.11-3.4.0.jar', sep=""))
  .jaddClassPath(paste(path, '/proto/target/dependency/netty-3.10.6.Final.jar', sep=""))
  .jaddClassPath(paste(path, '/proto/target/dependency/scala-library-2.11.2.jar', sep=""))
  .jaddClassPath(paste(path, '/proto/target/dependency/scalaz-core_2.11-7.2.0.jar', sep=""))
  .jaddClassPath(paste(path, '/proto/target/dependency/Agrona-0.9.0.jar', sep=""))
  .jaddClassPath(paste(path, '/proto/target/dependency/akka-remote_2.11-2.4.16.jar', sep=""))
  .jaddClassPath(paste(path, '/proto/target/dependency/jackson-core-2.6.7.jar', sep=""))
  .jaddClassPath(paste(path, '/proto/target/dependency/json4s-jackson_2.11-3.4.0.jar', sep=""))
  .jaddClassPath(paste(path, '/proto/target/dependency/paranamer-2.8.jar', sep=""))
  .jaddClassPath(paste(path, '/proto/target/dependency/scala-library-2.11.8.jar', sep=""))
  .jaddClassPath(paste(path, '/proto/target/dependency/ssl-config-core_2.11-0.2.1.jar', sep=""))
  .jaddClassPath(paste(path, '/proto/target/dependency/akka-actor_2.11-2.4.16.jar', sep=""))
  .jaddClassPath(paste(path, '/proto/target/dependency/akka-stream_2.11-2.4.16.jar', sep=""))
  .jaddClassPath(paste(path, '/proto/target/dependency/jackson-databind-2.6.7.jar', sep=""))
  .jaddClassPath(paste(path, '/proto/target/dependency/json4s-scalap_2.11-3.4.0.jar', sep=""))
  .jaddClassPath(paste(path, '/proto/target/dependency/reactive-streams-1.0.0.jar', sep=""))
  .jaddClassPath(paste(path, '/proto/target/dependency/scala-parser-combinators_2.11-1.0.4.jar', sep=""))
  .jaddClassPath(paste(path, '/proto/target/dependency/uncommons-maths-1.2.2a.jar', sep=""))

}
