% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/chisq.test.R
\name{chisq.test}
\alias{chisq.test}
\title{Chi-Square (Pearson's method) Test statistic with privacy preserving}
\usage{
chisq.test(params)
}
\arguments{
\item{params}{The <Parameters> that should be defined to compute the statistic.}
}
\value{
A set of resulted components after the chi-square test execution, like p-value, df, X^2
}
\description{
Chi-Square Test statistic that preserves the privacy of the data sources. The statistic is performed for exactly two sample.
}
\examples{
We want to apply a chi-square test between the sex (M,F) and the age (old, young).
Firstly we should define the <Parameters> value:
chiGr1 <- GroupStat( list( c("sex", "=", "M") , c("sex", "=", "F") ))
chiGr2 <- GroupStat( list( c("age", "=", "old") , c("age", "=", "young")))
chiParam <- Parameters( list() , list(chiGr1, chiGr2))
chisq.test(chiParam)

}
