% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/cor.R
\name{cor}
\alias{cor}
\title{Correlation Coefficient statistic with privacy preserving}
\usage{
cor(params)
}
\arguments{
\item{params}{The <Parameters> that should be defined to compute the statistic. The list of dependency field should have exactly the two variables for the correlation test.}
}
\value{
A double that represents the correlation result (range: [-1.0, 1.0] ).
}
\description{
Correlation Coefficient statistic that preserves the privacy of the data sources. The statistic is performed for exactly two variables.
}
\examples{
We want to apply a correlation test between the 2 variables: value_time_before, value_time_after.
Firstly we should define the variables through the <Parameters>.
The first element in the Dependent list defines how much the variable is correlated to the second one:
corParam <- Parameters( list("value_time_before", "value_time_after") , NULL)
cor(corParam)

}
