% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/lr.R
\name{lr}
\alias{lr}
\title{Simple Linear Regression statistic with privacy preserving}
\usage{
lr(params)
}
\arguments{
\item{params}{The <Parameters> that should be defined to compute the statistic. Linear Regression needs two variables in the 'dependency' field of the object Parameters. The first string specifies the independent variable while the second the independent one.}
}
\value{
A set of resulted components after the Linear Regression execution, like the coefficients (beta0 and beta1) and analytics (Sx, Sy, R2)
}
\description{
Simple Linear Regression statistic that preserves the privacy of the data sources.
The statistic is performed for exactly one dependent and one independent variable.
}
\examples{
We want to apply a linear regression test between the 2 variables: value_time_before, value_time_after.
Firstly we should define the variables through the <Parameters>:
The first element in the Dependent list defines how much the variable is related linearly to the second one
lParam <- Parameters( list("value_time_before", "value_time_after") , NULL )
lr(lParam)
}
