% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/mean.R
\name{mean}
\alias{mean}
\title{Mean statistic with privacy preserving}
\usage{
mean(params)
}
\arguments{
\item{params}{The <Parameters> that should be defined to compute the statistic.}
}
\value{
A double that represents the average result
}
\description{
Mean (Average) statistic that preserves the privacy of the data sources. The statistic is performed for exactly one sample.
}
\examples{
You want the mean of a single variable like the 'value_time_before'
Firstly www should define it through the dependent var of the <Parameters>:
mParam <- Parameters( list("value_time_before") , NULL)
mean(mParam)

Also we may want the mean of the variable 'value_time_before' only for the male population (eg. sex=M).
The variable should be specified into the DP list , while all the conditions should be declared through a group.
mGr <- GroupStat( list( c("sex","=","M")) )
mParam <- Parameters( list("value_time_before") , list(mGr) )
mean(mParam)
}
