% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/normality.R
\name{normality}
\alias{normality}
\title{Normality with privacy preserving (D’ Agostino-Pearson omnibus method)}
\usage{
normality(params, conf.level = 0.95)
}
\arguments{
\item{params}{The <Parameters> that should be defined to compute whether a sample follows a normal distribution.  For this computation a single sample group is needed.}

\item{conf.level}{The confidence level of the interval. It is the opposite of significance level. Default: 0.95}
}
\value{
A set of resulted components after the normality execution, like p-value, Zg1, Zg2 and if the sample is statistically significant normalised.
}
\description{
Checkes whether a sample follows a normal distribution. It needs a single dependency attribute.
}
\examples{
We want to check if the variable 'value_time_after' follows a normal distribution for the sample group where the people are female (sex=F).
Firstly we should define the <Parameters> with the DV and the IV:
nGr <- GroupStat( list( c("sex", "=", "F") ))
nParam <- Parameters( list("value_time_after") , list(nGr))
normality(nParam)
}
