% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/plotnorm.R
\name{plotnorm}
\alias{plotnorm}
\title{Plot the Normal Distribution Bell with privacy preserving}
\usage{
plotnorm(params)
}
\arguments{
\item{params}{The <Parameters> that should be defined to compute the statistic.}
}
\description{
Plots the gaussian bell with the use of mean and st.deviation while it preserves the privacy of the data sources. The method is performed for exactly a single sample.
}
\examples{
We want to plot the Gaussian distribution of the variable 'value_time_after' for the sample group where the people are female (sex=F).
Firstly we should define the <Parameters> with the DV and the IV:
nGr <- GroupStat( list( c("sex", "=", "F") ))
nParam <- Parameters( list("value_time_after") , list(nGr))
plotnorm(nParam)
}
