% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/stdev.R
\name{stdev}
\alias{stdev}
\title{Standard Deviation statistic with privacy preserving}
\usage{
stdev(params)
}
\arguments{
\item{params}{The <Parameters> that should be defined to compute the statistic.}
}
\value{
A double that represents the standard deviation result
}
\description{
Standard Deviation statistic that preserves the privacy of the data sources. The statistic is performed for exactly a single sample.
}
\examples{
We want the st. deviation of a single variable like the 'value_time_before'
Firstly we should define it through the dependent list of the <Parameters>:
stParam <- Parameters( list("value_time_before") , NULL )
stdev(stParam)

Also we may want the st.deviation of the variable 'value_time_before' only for the male population (eg. sex=M).
The variable should be specified into the DP list , while all the conditions should be declared through a group.
stGr <- GroupStat( list( c("sex","=","M")) )
stParam <- Parameters( list("value_time_before") , list(stGr) )
stdev(stParam)
}
