% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/ttest.R
\name{ttest}
\alias{ttest}
\title{T-test statistic with privacy preserving}
\usage{
ttest(params, alternative = "t", mu = 0, varEq = FALSE,
  conf.level = 0.95)
}
\arguments{
\item{params}{The <Parameters> that should be defined to compute the statistic. T-test statistic needs exactly 2 groups-samples.}

\item{alternative}{A character string specifying the alternative hypothesis, must be one of "two.sided" (default), "greater" or "less". You can specify just the initial letter.}

\item{mu}{A double number indicating the difference in means and declares the Ho hypothesis.}

\item{varEq}{A logical variable indicating whether to treat the two variances as being equal.
If TRUE then the Student T-test is used otherwise the Welch (or Satterthwaite) approximation to the degrees of freedom is used.}

\item{conf.level}{The confidence level of the interval. It is the opposite of significance level.}
}
\value{
A set of resulted components after the T-test execution, like p-value, t-value etc
}
\description{
T-test statistic that preserves the privacy of the data sources. The statistic is performed for exactly two samples.
}
\examples{
We want to apply a t-test on the dependend variable 'value_time_before' where the independent variable is sex(M, F).
Firstly we should define the <Parameters>:
tGr1 <- GroupStat( list( c("sex", "=", "M") ))
tGr2 <- GroupStat( list( c("sex", "=", "F") ))
tParam <- Parameters( list("value_time_before") , list(tGr1, tGr2))

To run the Welch method for t-test, type:
ttest(tParam, varEq = FALSE)

}
