% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/var.R
\name{var}
\alias{var}
\title{Variance statistic with privacy preserving}
\usage{
var(params)
}
\arguments{
\item{params}{The <Parameters> that should be defined to compute the statistic.}
}
\value{
A double that represents the variance result
}
\description{
Variance statistic that preserves the privacy of the data sources. The statistic is performed for exactly a single sample.
}
\examples{
We want the variance of a single variable like the 'value_time_before'
Firstly we should define it through the dependent list of the <Parameters>:
vParam <- Parameters( list("value_time_before") , NULL)
var(vParam)

Also we may want the variance of the variable 'value_time_before' only for the male population (eg. sex=M).
The variable should be specified into the DP list , while all the conditions should be declared through a group.
vGr <- GroupStat( list( c("sex","=","M")) )
vParam <- Parameters( list("value_time_before") , list(vGr) )
var(stParam)
}
