package gr.demokritos.iit.radio.home.protocols

import akka.actor.Address
import com.typesafe.config.Config
import scala.collection.immutable
import akka.japi.Util.immutableSeq
import akka.actor.AddressFromURIString


/**
  * Created by angel on 25/4/2017.
  */
class RASSPConfig(var config : Config, val systemName : String) {


  private val cc = config.getConfig("rassp")

  val PeerNodes : immutable.IndexedSeq[Address] =
    immutableSeq(cc.getStringList("peers")).map { case AddressFromURIString(addr) => addr }.toVector

  val GroupProxies : immutable.IndexedSeq[Address] =
    immutableSeq(cc.getStringList("group-proxies")).map { case AddressFromURIString(addr) => addr }.toVector

}


object RASSPConfig {

  def apply(config : Config, systemName : String) = new RASSPConfig(config, systemName)

}
